<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/ads/googleads/v17/services/recommendation_service.proto

namespace Google\Ads\GoogleAds\V17\Services;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [RecommendationService.DismissRecommendation][google.ads.googleads.v17.services.RecommendationService.DismissRecommendation].
 *
 * Generated from protobuf message <code>google.ads.googleads.v17.services.DismissRecommendationRequest</code>
 */
class DismissRecommendationRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The ID of the customer with the recommendation.
     *
     * Generated from protobuf field <code>string customer_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $customer_id = '';
    /**
     * Required. The list of operations to dismiss recommendations.
     * If partial_failure=false all recommendations should be of the same type
     * There is a limit of 100 operations per request.
     *
     * Generated from protobuf field <code>repeated .google.ads.googleads.v17.services.DismissRecommendationRequest.DismissRecommendationOperation operations = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $operations;
    /**
     * If true, successful operations will be carried out and invalid
     * operations will return errors. If false, operations will be carried in a
     * single transaction if and only if they are all valid.
     * Default is false.
     *
     * Generated from protobuf field <code>bool partial_failure = 2;</code>
     */
    protected $partial_failure = false;

    /**
     * @param string                                                                                           $customerId Required. The ID of the customer with the recommendation.
     * @param \Google\Ads\GoogleAds\V17\Services\DismissRecommendationRequest\DismissRecommendationOperation[] $operations Required. The list of operations to dismiss recommendations.
     *                                                                                                                     If partial_failure=false all recommendations should be of the same type
     *                                                                                                                     There is a limit of 100 operations per request.
     *
     * @return \Google\Ads\GoogleAds\V17\Services\DismissRecommendationRequest
     *
     * @experimental
     */
    public static function build(string $customerId, array $operations): self
    {
        return (new self())
            ->setCustomerId($customerId)
            ->setOperations($operations);
    }

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $customer_id
     *           Required. The ID of the customer with the recommendation.
     *     @type array<\Google\Ads\GoogleAds\V17\Services\DismissRecommendationRequest\DismissRecommendationOperation>|\Google\Protobuf\Internal\RepeatedField $operations
     *           Required. The list of operations to dismiss recommendations.
     *           If partial_failure=false all recommendations should be of the same type
     *           There is a limit of 100 operations per request.
     *     @type bool $partial_failure
     *           If true, successful operations will be carried out and invalid
     *           operations will return errors. If false, operations will be carried in a
     *           single transaction if and only if they are all valid.
     *           Default is false.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Ads\GoogleAds\V17\Services\RecommendationService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The ID of the customer with the recommendation.
     *
     * Generated from protobuf field <code>string customer_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getCustomerId()
    {
        return $this->customer_id;
    }

    /**
     * Required. The ID of the customer with the recommendation.
     *
     * Generated from protobuf field <code>string customer_id = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setCustomerId($var)
    {
        GPBUtil::checkString($var, True);
        $this->customer_id = $var;

        return $this;
    }

    /**
     * Required. The list of operations to dismiss recommendations.
     * If partial_failure=false all recommendations should be of the same type
     * There is a limit of 100 operations per request.
     *
     * Generated from protobuf field <code>repeated .google.ads.googleads.v17.services.DismissRecommendationRequest.DismissRecommendationOperation operations = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getOperations()
    {
        return $this->operations;
    }

    /**
     * Required. The list of operations to dismiss recommendations.
     * If partial_failure=false all recommendations should be of the same type
     * There is a limit of 100 operations per request.
     *
     * Generated from protobuf field <code>repeated .google.ads.googleads.v17.services.DismissRecommendationRequest.DismissRecommendationOperation operations = 3 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param array<\Google\Ads\GoogleAds\V17\Services\DismissRecommendationRequest\DismissRecommendationOperation>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setOperations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Ads\GoogleAds\V17\Services\DismissRecommendationRequest\DismissRecommendationOperation::class);
        $this->operations = $arr;

        return $this;
    }

    /**
     * If true, successful operations will be carried out and invalid
     * operations will return errors. If false, operations will be carried in a
     * single transaction if and only if they are all valid.
     * Default is false.
     *
     * Generated from protobuf field <code>bool partial_failure = 2;</code>
     * @return bool
     */
    public function getPartialFailure()
    {
        return $this->partial_failure;
    }

    /**
     * If true, successful operations will be carried out and invalid
     * operations will return errors. If false, operations will be carried in a
     * single transaction if and only if they are all valid.
     * Default is false.
     *
     * Generated from protobuf field <code>bool partial_failure = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setPartialFailure($var)
    {
        GPBUtil::checkBool($var);
        $this->partial_failure = $var;

        return $this;
    }

}

